#pragma once

#include <ReferenceCounter.h>
#include <Trie.h>

#include "ChunkMap.h"

class DimensionMap : public Framework::ReferenceCounter
{
private:
    Framework::Trie<ChunkMap>* chunks;
    Framework::Critical cs;
    int dimensionId;

    ChunkMap* load(Framework::Punkt chunkCenter);

public:
    DimensionMap(int dimensionId);
    ~DimensionMap();

    void loadMap(char* addr, int addrLen, Chunk* zChunk);
    void saveMap(char* addr, int addrLen);
    void removeMap(char* addr, int addrLen);
    ChunkMap* getMap(char* addr, int addrLen, Framework::Punkt chunkCenter);
};